function  C2p29_PSET2_10p6
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #3, Textbook Problem #10.6
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,clc
format short
A=[10 2 -1;-3 -6 2 ; 1 1 5];
L=[1 0 0;-.3 1 0;.1 -.148 1]
U=[10 2 -1;0 -5.4 1.7 ; 0 0 5.35]
b=[27 -61.5 -21.5]';

I=eye(3);
inv_A=[solve(I(:,1)) solve(I(:,2)) solve(I(:,3))]
inv_A_exact=inv(A)

A_inv_A_A=A*inv(A)
x_sol=solve(b)
x_sol_exact=inv(A)*b
residual=A*x_sol-b

    function x=solve(b)

        y(1)=chop(b(1));
        y(2)=chop(b(2)-chop(L(2,1)*y(1)));
        y(3)=chop(b(3)-chop(chop(L(3,1)*y(1))+chop(L(3,2)*y(2))) );


        x(3,1)=chop(y(3)/U(3,3));
        x(2,1)=chop(chop(y(2)-chop(U(2,3)*x(3)))/U(2,2));
        x(1,1)=chop(chop(y(1)-chop(chop(U(1,3)*x(3))+chop(U(1,2)*x(2))))/U(1,1));

        function y=chop(x)
            r=2; % r+1: # of significant digits
            if x==0
                y=x;
            else
                n=floor(log10(abs(x)));

                y=10^(n-r)*round(abs(x)*10^(-n+r))*sign(x);
            end
        end

    end
end