function  [Cost_Normalized,MN]=C2p29_PSET2_4()
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #1
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

%clc
clear all,close all


k=1;
Clock=2e9;
 Basic_Costs; %%
% pause

fprintf('\n\n\n\t\t Data Type: Double')

fprintf('\n\t\t \t\t\t\t   Time Cost Normalized by CPU Clock')
fprintf('\n\t\t n\t\t m\t\t Scalar \t Vector\t\t Matrix')
fprintf('\n\t\t --------------------------------------------------------------------------------')
MN=[
    10  100 1000    10  100 1000    10  100 1000 1    10   50   10   2     2    2
    1   1   1       10  10  10      100 100 100  1000 1000 1000 2000 5000 10000 100000];

MN=[
    100
    100];

for k=1:size(MN,2)
    m=MN(1,k);
    n=MN(2,k);
    %% Scalar
    tic, clear c a b
    c=rand;a=rand;b=rand;
    if n^2*m<100000
        for i=1:n^2*m;
            a=rand;
            b=rand;

            c=a; %Assignment Cost
            c=a+b;
            c=a-b;
            c=a*b;
            c=a/b;

            c=abs(a);
            c=a^2;
            c=a^3;
            c=a^.5;
            c=sqrt(a);

            c=sin(a);
            c=cos(a);
            c=tan(a);

            c=exp(a);
            c=exp(-a);
            c=log(a);

        end
        S_cost(k)=toc*Clock/(m*n^2);
    else
        S_cost(k)=NaN;
    end


    %% Vector
    tic, clear c a b,
    c=rand(n,1);a=rand(n,1);b=rand(n,1);
    for i=1:m*n;
        a=rand(n,1);
        b=rand(n,1);

        c=a; %Assignment Cost
        c=a+b;
        c=a-b;
        c=a.*b;
        c=a./b;

        c=abs(a);
        c=a.^2;
        c=a.^3;
        c=a.^.5;
        c=sqrt(a);

        c=sin(a);
        c=cos(a);
        c=tan(a);

        c=exp(a);
        c=exp(-a);
        c=log(a);

    end
    V_cost(k)=toc*Clock/(m*n^2);

    %% Matrix
    if n^2*m<51e6
        tic, clear c a b
        c=rand(n,n);a=rand(n,n);b=rand(n,n);
        for i=1:m
            a=rand(n,n);
            b=rand(n,n);

            c=a; %Assignment Cost
            c=a+b;
            c=a-b;
            c=a.*b;
            c=a./b;

            c=abs(a);
            c=a.^2;
            c=a.^3;
            c=a.^.5;
            c=sqrt(a);

            c=sin(a);
            c=cos(a);
            c=tan(a);

            c=exp(a);
            c=exp(-a);
            c=log(a);

        end
        M_cost(k)=toc*Clock/(m*n^2);
    else
        M_cost(k)=toc*Clock/(m*n^2);
    end

    fprintf('\n\t\t %d \t\t %d \t\t %7.0f \t %7.0f \t %7.0f',n,m,S_cost(k),V_cost(k),M_cost(k))
end
fprintf('\n')
Cost_Normalized=[S_cost V_cost M_cost];

function Basic_Costs

for q=1:10
    for j=1:10
        A=0;
        for i=1000
            tic
            A=toc+A;
        end
        tic_toc_Average(j)=A/1000*Clock;
    end
    tic_toc_Average;
    tic_toc_mean=mean(tic_toc_Average);
    tic_toc_std_pcnt=std(tic_toc_Average)/tic_toc_mean*100;

    fprintf('\n\t tic_toc_mean=%5.2f \t tic_toc_std_pcnt=%5.2f%',tic_toc_mean,tic_toc_std_pcnt);
end
pause

A=0;
i=1;
figure
tic_toc=zeros(10,1);
for q=1:3
    for j=0:4
        i_max=10^j;
        for m=1:10
            tic
            for i=1:i_max
                M=2;
            end
            A=toc;
            tic_toc(m)=A/i_max*Clock-tic_toc_mean;
        end
        for_mean=mean(tic_toc);
        for_std=std(tic_toc);
        errorbar(i_max,for_mean,for_std,'*'), hold on
        %pause
    end

end
hold on, box on, grid on
FN_Size_A=16;
FN_Size_T=14;
set(gca,'fontsize',14)
xlabel('Size of for Loop','fontsize',FN_Size_A,...
    'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel('For loop cost normalized by clock time','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
title (['Time cost of for loops'],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

%legend('\sigma_{rr}','\sigma_{\theta\theta}','\sigma_{Mises}','Location','Southwest')
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
set(gcf,'Position',[50 50 [20 18]*40],'color','w')

set(gca,'Xscale','log')
end
end
